% BO - Magnitude Optimum (BetragsOptimum) Continuous Controller Optimization Toolbox
% Version 1.1  21-September-2023
%
% introduction  >>>https://wwwpub.zih.tu-dresden.de/~geitner/ae_2e.htm<<<
% m-Files     >>>https://wwwpub.zih.tu-dresden.de/~geitner/ae_2_2e.htm<<<
%
%Controller calculation - main functions
%   bo_u_gen     - Magnitude optimum (Betragsoptimum) controller 
%                  optimization: I-, PI-, PID- and PID2-type, undelayed 
%                  input (without pre-filter), one integrator in open loop;
%   bo_u_gen02   - same as bo_u_gen, but two higher order controllers 
%                  possible;
%   bo_d_gen     - Magnitude optimum (Betragsoptimum) controller 
%                  optimization: PI-, PID-, PID2-type, delayed input 
%                  (pre-filter, so-called Symmetrisches Optimum), variable
%                  number of open loop integrators;
%   bo_d_gen02   - same as bo_d_gen, but two higher order controllers 
%                  possible, revised equation system;
%   bo_prefi_op  - Magnitude Optimum (Betragsoptimum) optional prefilter 
%                  optimization (second step), to decrease overshoot more;
%   bo_prefi_op02- same as bo_prefi, but additional any pre-filter for
%                  reference system possible;
%
%Controller calculation - more functions
%   bo_d_pltgen  - Magnitude optimum (Betragsoptimum) controller 
%                  optimization: PI-, PID-, PID2-type, delayed inputs; 
%                  unlike bo_d_gen: pre-filter output available, 
%                  LTI definitions of plant and controller;
%   bo_d_speso   - PID-type controller optimization based on 
%                  Magnitude Optimum (Betragsoptimum) for delayed inputs 
%                  (pre-filter, Symmetric Optimum) for four special plant 
%                  structures;
%   bo_d_PI      - same as bo_d_gen, but PI-type controller only, direct 
%                  solution of a quadratic equation, no use of a solver for
%                  nonlinear systems of equations
%
%Check
%   bo_check    - accuracy check for fulfillment of basic Magnitude Optimum
%                 equations;
%
%For Comparison
%   dr_d_wedz   - PID-type controller optimization based on Naslin Method
%                 (Doppelverhltnisse) for delayed inputs (pre-filter, 
%                 optional: double zero) for four special plant structures;

% Copyright (c) 2023 -  Dr. G.-H. Geitner, TU Dresden.
% All Rights Reserved.
% Last change: 2023/21/09.
